@echo off
echo =========================================================
echo HeatBooster firmware updater
echo (c) 2022 SDR Engineering - onderdeel van Solardoctor B.V.
echo =========================================================
echo.
echo.
echo QUICK MANUAL
echo ------------
echo Before continuing, make sure there are no cables connected to the HeatBooster.
echo 1) Do the following in case your HeatBooster has a PROG-button on the PCB, otherwise skip to step 2 (ie. do not connect 12V in this case).
echo    - Hold the PROG-button while connecting the 12V adapter to the HeatBooster.
echo    - If the LED on the board is lit in very dim green, release the PROG-button.
echo      Note: the LED should not be blinking or bright green, in that case, try step 1 again.
echo 2) Connect the HeatBooster with your computer via USB.
echo 3) Wait for your computer to install the appropriate USB drivers for the device.
echo 4) Press [ENTER] to start flashing, or enter the COM-port to skip the search.
echo 5) The updater will search for the correct COM-port, and might try them all. Just have some patience.
echo.
echo Warning: updating the firmware will erase the configuration of the module.
echo Warning: this firmware updater is only compatible with board version R05 and later
echo.
echo ------------
echo.

:PRG
set COMPORT=
set /p COMPORT=COM-port of module (leave empty to search):

IF [%COMPORT%] == [] GOTO COM_SCAN

:COM_DETECTED
echo Updating firmware...
.\esptool.exe --chip esp32c3 --baud 921600 --port %COMPORT% --before usb_reset write_flash 0x0000 .\firmware.bin
GOTO PRGDONE

:COM_SCAN
echo Autodetecting COM-port and updating firmware...
echo.
.\esptool.exe --chip esp32c3 --baud 921600 --port-filter vid=0x303A --before usb_reset write_flash 0x0000 .\firmware.bin
GOTO PRGDONE


:PRGDONE
IF ERRORLEVEL 1 GOTO PRGERROR
echo.
echo Flashing succesful.
goto DONE

:PRGERROR
echo.
echo An error occured! Flashing failed.
pause

:DONE
echo.
set /p Q=Flash another module? (y/[n])

IF "%Q%" == "y" GOTO PRG

pause